"""
$RCSfile: CVSFileBatch.py,v $

A Factory for creating batches of CVSFile instances in one go.

Author: <a href="mailto:cstrong@arielpartners.com">Craeg Strong</a>
Release: 1.0
"""

__cvstag__  = '$Name:  $'[6:-2]
__date__    = '$Date: 2002/05/28 01:30:24 $'[6:-2]
__version__ = '$Revision: 1.2 $'[10:-2]

# Local modules
from CVSFile import CVSFile

# Peer classes
from Products.ExternalFile.FileUtils import dirlist

# Zope builtins
from Globals import DTMLFile, MessageDialog

# python builtins
import os.path

################################################################
# Container Methods
################################################################

# globals() is standard python for passing the current namespace
manage_batch_addForm = DTMLFile('dtml/batch_create', globals())

def manage_batch_add(self, 
                     target_dir, basedir='', REQUEST=None):
    """

    Factory method to actually create a batch of instances of
    CVSFile.  

    """
    message = "<h2>CVS File Batch Create Results:</h2>"

    try:
        filelist = dirlist(os.path.join(basedir, target_dir))

        if len(filelist) == 0:
            message = message + "No files found."
        
        for fileid, filepath in filelist:
            relfilepath = filepath.replace(basedir, '')
            message = message + "Object instance '" + \
                      fileid + \
                      "' successfully created, pointing to file: " + \
                      relfilepath + "<br/>"
        
            self._setObject(fileid, CVSFile(fileid, '', '', relfilepath))
            self._getOb(fileid).reindex_object()

    except OSError, e:
        message = message + str(e)
        
    return MessageDialog(title   = 'results',
                         message = message,
                         action  = 'manage_main')

################################################################
# CVSFileBatch class
################################################################

class CVSFileBatch:
    """

    CVSFileBatch is a factory for creating instances of CVSFile a
    batch at a time

    """

    meta_type = 'CVS File Batch'
