"""
$RCSfile: OSUtils.py,v $

Operating system library calls that are called from multiple modules
are collected here to avoid duplication.

Author: <a href="mailto:cstrong@arielpartners.com">Craeg Strong</a>
Release: 1.0
"""

__cvstag__  = '$Name:  $'[6:-2]
__date__    = '$Date: 2002/05/27 22:30:28 $'[6:-2]
__version__ = '$Revision: 1.2 $'[10:-2]

# Python builtins
import errno, os, sys, types

def runCommand(command):
    """

    send passed in commandline to OS, return output or '(no
    output)' if there is no output

    """
    # print "running this command", command
    input, output_and_error  = os.popen4(command)
    output = output_and_error.read()
    if not output:
        output = "(no output)"
    return output

def canonicalizeDir(dirname):
    """

    Adds a trailing slash to a directory.  Not necessary for
    correctness, since we ultimately use
    
    os.path.join(basedir, filepath)

    but it makes it look cleaner in a GUI and removes a
    source of potential user confusion.

    """
    lastChar = dirname[len(dirname) - 1]
    if lastChar != os.sep:
        return dirname + os.sep
    else:
        return dirname

command_separator       = ';'
if sys.platform == 'win32':
    command_separator = '&'
